<script>

  import { beforeUpdate, onMount } from 'svelte';

  export let setApp   = null;
  export let number   = '';
  export let contacts = [];

  export let dialerNumber = '';

  const audio = {};

  function pressKey(key) {
    key = key.toString();
    audio[key].currentTime = 0.0;
    audio[key].play();
    dialerNumber += key;
  }

  onMount(() => {

    audio['0'] = new Audio('./audio/DTMF_0.mp3');
    audio['1'] = new Audio('./audio/DTMF_1.mp3');
    audio['2'] = new Audio('./audio/DTMF_2.mp3');
    audio['3'] = new Audio('./audio/DTMF_3.mp3');
    audio['4'] = new Audio('./audio/DTMF_4.mp3');
    audio['5'] = new Audio('./audio/DTMF_5.mp3');
    audio['6'] = new Audio('./audio/DTMF_6.mp3');
    audio['7'] = new Audio('./audio/DTMF_7.mp3');
    audio['8'] = new Audio('./audio/DTMF_8.mp3');
    audio['9'] = new Audio('./audio/DTMF_9.mp3');
    audio['*'] = new Audio('./audio/DTMF_Et.mp3');
    audio['#'] = new Audio('./audio/DTMF_Di.mp3');

    for(let k in audio)
      audio[k].volume = 0.25;

  });

</script>

<style>

  @import url('https://fonts.googleapis.com/css?family=Lexend+Deca&display=swap');

  .app-dialer {
    width: calc(100% - 16px);
    height: 100%;
    display: flex;
    flex-direction: column;
    justify-content: space-evenly;
    font-family: 'Lexend Deca', sans-serif;
  }

  .dialer-pad {
    width: 100%;
    height: 60%;
    display: flex;
    flex-direction: column;
    justify-content: space-evenly;
    font-size: 3em;
    user-select: none;
  }

  .dialer-row {
    display: flex;
    flex-direction: row;
    justify-content: space-around;
    height: 100%;
  }

  .dialer-key {
    width: 100%;
    height: 100%;
    text-align: center;
    display: flex;
    flex-direction: row;
    align-items: center;
    justify-content: center;
    background-color: #000;
    border: 1px solid rgba(255, 255, 255, 0.1);
    color: rgb(133, 133, 133);
  }

  .dialer-key:active {
    color: rgb(58, 127, 255);
  }

  .dialer-row .dialer-key:not(:first-child) {
    margin-left: -1px;
  }

  .dialer-number input {
    width: 100%;
    height: 64px;
    font-size: 2.5em;
    line-height: 2.5em;
    background-color: rgba(0, 0, 0, 0.75);
    border: 1px solid rgba(255, 255, 255, 0.2);
    color: #FFF;
    text-align: center;
  }

  .dialer-submit {
    background-color: rgba(0, 0, 0, 0.25);
    height: 64px;
    display: flex;
    flex-direction: row;
    align-items: center;
    justify-content: center;
    background-color: rgba(255, 255, 255, 0.1);
  }

  .dialer-submit:hover {
    color: rgb(58, 127, 255);
    background-color: rgba(255, 255, 255, 0.15);
  }

</style>

<div class="app-dialer">

  <div class="dialer-number">
    <input type="text" bind:value={dialerNumber}/>
  </div>

  <div class="dialer-pad">

    <div class="dialer-row">
      <button class="dialer-key" on:mousedown={e => pressKey('1')}>1</button>
      <button class="dialer-key" on:mousedown={e => pressKey('2')}>2</button>
      <button class="dialer-key" on:mousedown={e => pressKey('3')}>3</button>
    </div>

    <div class="dialer-row">
      <button class="dialer-key" on:mousedown={e => pressKey('4')}>4</button>
      <button class="dialer-key" on:mousedown={e => pressKey('5')}>5</button>
      <button class="dialer-key" on:mousedown={e => pressKey('6')}>6</button>
    </div>

    <div class="dialer-row">
      <button class="dialer-key" on:mousedown={e => pressKey('7')}>7</button>
      <button class="dialer-key" on:mousedown={e => pressKey('8')}>8</button>
      <button class="dialer-key" on:mousedown={e => pressKey('9')}>9</button>
    </div>

    <div class="dialer-row">
      <button class="dialer-key" on:mousedown={e => pressKey('*')}>*</button>
      <button class="dialer-key" on:mousedown={e => pressKey('0')}>0</button>
      <button class="dialer-key" on:mousedown={e => pressKey('#')}>#</button>
    </div>
  
  </div>

  <div class="dialer-submit" on:mouseup={e => setApp('outgoingcall', {to: dialerNumber})}>
    <i class="fas fa-phone fa-2x"></i>
  </div>

</div>